/*
 *   Copyright (c) 1996-1999 David Parsons. All rights reserved.
 *   
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions
 *   are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in
 *     the documentation and/or other materials provided with the
 *     distribution.
 *  3. All advertising materials mentioning features or use of this
 *     software must display the following acknowledgement:
 *     
 *   This product includes software developed by David Parsons
 *   (orc@pell.chi.il.us)
 *
 *  4. My name may not be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *     
 *  THIS SOFTWARE IS PROVIDED BY DAVID PARSONS ``AS IS'' AND ANY
 *  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 *  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL DAVID
 *  PARSONS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 *  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 *  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 *  THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * paths to things we're interested in
 */
#ifndef _PATHNAME_D
#define _PATHNAME_D

#define TARGET		"/disk"
#define SOURCE		"/cdrom"
#define TOOL_DIR	"/Tools"
#define PATCH		"/PATCH"	/* patchfile on floppy */
#define	CACHE		"/CACHE"	/* for upgrades */
#define	PATH_TAR	"/bin/tar"
#define PATH_WGET	"/usr/bin/wget"
#define PATH_PROBE	"/sbin/probe"
#define PATH_MKFS	"/sbin/mke2fs"			/* need to retrieve? */
#define PATH_MKSWAP	"/sbin/mkswap"			/* need to retrieve? */
#define PATH_CFDISK	"/sbin/cfdisk"			/* need to retrieve? */
#define PATH_SFDISK	"/sbin/sfdisk"			/* need to retrieve? */
#define PATH_INSMOD	"/sbin/insmod"
#define PATH_CARDMGR	"/sbin/cardmgr"
#define PATH_DHCLIENT	"/sbin/dhcpcd"
#define PATH_IFCONFIG	"/sbin/ifconfig"
#define PATH_SH		"/bin/sh"
#define	PATH_GPM	"/bin/gpm"
#define PATH_PKGS	SOURCE "/"

#define PACKAGES	"mastodon.toc"

#define KERNEL		"/boot/BASIC"	/* the kernel we use */
#define MY_KERNEL	KERNEL
#define MY_MAP		KERNEL ".map"

#endif/*_PATHNAME_D*/
